<?php
class datetimerangeClass extends processFieldValue
{
	public $name = 'Date Time range';
	public $configuration = true;
	public $search_configuration = false;
	public $order_option = false;

	/**
     * Overload of processFieldValue::select($custom_group_name, $object_id)
     *
     */
	public function select($custom_group_name, $object_id)
    {
    	$CI = &get_instance();

    	$CI->content_fields->db->select();
    	$CI->content_fields->db->from('content_fields_type_' . $this->field->type . '_data');
    	$CI->content_fields->db->where('field_id', $this->field->id);
    	$CI->content_fields->db->where('custom_name', $custom_group_name);
    	$CI->content_fields->db->where('object_id', $object_id);
    	$query = $CI->content_fields->db->get();
    	
    	if ($query->num_rows()) {
    		$row = $query->row_array();
    		$this->field->value = array('from_field_value' => $row['from_field_value'], 'to_field_value' => $row['to_field_value']);
    		$this->field->field_value_id = $row['id'];
    	} else {
    		$this->field->value = array('from_field_value' => '', 'to_field_value' => '');
    	}
    }
    
    /**
     * Overload of processFieldValue::save($custom_group_name, $object_id, $form_result)
     *
     */
    public function save($custom_group_name, $object_id, $form_result)
    {
    	$CI = &get_instance();

    	$from_field_name = 'from_' . $this->field->seo_name;
    	$from_tmsmp_field_name = 'from_tmstmp_' . $this->field->seo_name;
    	
    	$to_field_name = 'to_' . $this->field->seo_name;
    	$to_tmsmp_field_name = 'to_tmstmp_' . $this->field->seo_name;
    	
    	// Handle hours, minutes, seconds
    	$from_time_h = $form_result['from_h_' . $this->field->seo_name];
    	$from_time_m = $form_result['from_m_' . $this->field->seo_name];
    	$from_time_s = $form_result['from_s_' . $this->field->seo_name];
    	$from_time_h = ($from_time_h == '') ? '00' : $from_time_h;
    	$from_time_m = ($from_time_m == '') ? '00' : $from_time_m;
    	$from_time_s = ($from_time_s == '') ? '00' : $from_time_s;
    	
    	$to_time_h = $form_result['to_h_' . $this->field->seo_name];
    	$to_time_m = $form_result['to_m_' . $this->field->seo_name];
    	$to_time_s = $form_result['to_s_' . $this->field->seo_name];
    	$to_time_h = ($to_time_h == '') ? '00' : $to_time_h;
    	$to_time_m = ($to_time_m == '') ? '00' : $to_time_m;
    	$to_time_s = ($to_time_s == '') ? '00' : $to_time_s;

    	if (!empty($form_result[$from_field_name]) || !empty($form_result[$to_field_name])) {
    		if (!empty($form_result[$from_field_name])) {
	    			$from_date_time = date('Y-m-d', $form_result[$from_tmsmp_field_name]) . ' ' . $from_time_h . ':' . $from_time_m . ':' . $from_time_s;
	    	} else {
	    		$from_date_time = '0000-00-00';
	    	}

	    	if (!empty($form_result[$to_field_name])) {
	    		$to_date_time = date('Y-m-d', $form_result[$to_tmsmp_field_name]) . ' ' . $to_time_h . ':' . $to_time_m . ':' . $to_time_s;
	    	} else {
	    		$to_date_time = '9999-12-31';
	    	}

    		$CI->content_fields->db->set('from_field_value', $from_date_time);
	    	$CI->content_fields->db->set('to_field_value', $to_date_time);
	    	$CI->content_fields->db->set('field_id', $this->field->id);
	    	$CI->content_fields->db->set('custom_name', $custom_group_name);
	    	$CI->content_fields->db->set('object_id', $object_id);
	    	return $CI->content_fields->db->insert('content_fields_type_' . $this->field->type . '_data');
    	} else {
    		return true;
    	}
    }
    
    /**
     * Overload of processFieldValue::update($custom_group_name, $object_id, $form)
     *
     */
    public function update($custom_group_name, $object_id, $form_result)
    {
    	$CI = &get_instance();

    	if ($this->field->field_value_id == 'new') {
    		return $this->save($custom_group_name, $object_id, $form_result);
    	} else {
    		$from_field_name = 'from_' . $this->field->seo_name;
	    	$from_tmsmp_field_name = 'from_tmstmp_' . $this->field->seo_name;

	    	$to_field_name = 'to_' . $this->field->seo_name;
	    	$to_tmsmp_field_name = 'to_tmstmp_' . $this->field->seo_name;

	    	// Handle hours, minutes, seconds
	    	$from_time_h = $form_result['from_h_' . $this->field->seo_name];
	    	$from_time_m = $form_result['from_m_' . $this->field->seo_name];
	    	$from_time_s = $form_result['from_s_' . $this->field->seo_name];
	    	$from_time_h = ($from_time_h == '') ? '00' : $from_time_h;
	    	$from_time_m = ($from_time_m == '') ? '00' : $from_time_m;
	    	$from_time_s = ($from_time_s == '') ? '00' : $from_time_s;

	    	$to_time_h = $form_result['to_h_' . $this->field->seo_name];
	    	$to_time_m = $form_result['to_m_' . $this->field->seo_name];
	    	$to_time_s = $form_result['to_s_' . $this->field->seo_name];
	    	$to_time_h = ($to_time_h == '') ? '00' : $to_time_h;
	    	$to_time_m = ($to_time_m == '') ? '00' : $to_time_m;
	    	$to_time_s = ($to_time_s == '') ? '00' : $to_time_s;

	    	//if (!empty($form_result[$from_field_name]) || !empty($form_result[$to_field_name])) {
	    		if (!empty($form_result[$from_field_name])) {
	    			$from_date_time = date('Y-m-d', $form_result[$from_tmsmp_field_name]) . ' ' . $from_time_h . ':' . $from_time_m . ':' . $from_time_s;
	    		} else {
	    			$from_date_time = '0000-00-00';
	    		}

	    		if (!empty($form_result[$to_field_name])) {
	    			$to_date_time = date('Y-m-d', $form_result[$to_tmsmp_field_name]) . ' ' . $to_time_h . ':' . $to_time_m . ':' . $to_time_s;
	    		} else {
	    			$to_date_time = '9999-12-31';
	    		}

	    		$CI->content_fields->db->set('from_field_value', $from_date_time);
		    	$CI->content_fields->db->set('to_field_value', $to_date_time);
		    	$CI->content_fields->db->where('field_id', $this->field->id);
		    	$CI->content_fields->db->where('custom_name', $custom_group_name);
		    	$CI->content_fields->db->where('object_id', $object_id);
		    	return $CI->content_fields->db->update('content_fields_type_' . $this->field->type . '_data');
	    	/*} else {
	    		return true;
	    	}*/
    	}
    }
    
    /**
     * Overload of processFieldValue::getValueFromForm($form)
     * 
     * Return field's value after the form was not valid
     *
     * @param object $form
     */
    public function getValueFromForm($form_result)
    {
    	$CI = &get_instance();

    	$seo_name = $this->field->seo_name;
    	// is 'from' input was filled?
    	if (!empty($form_result['from_tmstmp_' . $seo_name]) AND $form_result['from_tmstmp_' . $seo_name] != 'NaN') {
    		$from_tmstmp = date("Y-m-j", $form_result['from_tmstmp_' . $seo_name]) . 
	    													' ' . $form_result['from_h_' . $seo_name] . 
	    													':' . $form_result['from_m_' . $seo_name] . 
	    													':' . $form_result['from_s_' . $seo_name];
    	} else {
    		$from_tmstmp = '';
    	}
    	// is 'to' input was filled?
    	if (!empty($form_result['to_tmstmp_' . $seo_name]) AND $form_result['to_tmstmp_' . $seo_name] != 'NaN') {
    		$to_tmstmp = date("Y-m-j", $form_result['to_tmstmp_' . $seo_name]) . 
	    													' ' . $form_result['to_h_' . $seo_name] . 
	    													':' . $form_result['to_m_' . $seo_name] . 
	    													':' . $form_result['to_s_' . $seo_name];
    	} else {
    		$to_tmstmp = '';
    	}

	    $this->field->value = array('from_field_value' => $from_tmstmp, 
	    							'to_field_value' => $to_tmstmp);
    }

    public function renderDataEntry()
    {
    	$CI = &get_instance();

        $view = $CI->load->view();
        $view->assign('field', $this->field);
        $view->assign('from_date', $this->field->value['from_field_value']);
        $view->assign('to_date', $this->field->value['to_field_value']);
        $view->assign('from_date_tmstmp', strtotime($this->field->value['from_field_value']));
        $view->assign('to_date_tmstmp', strtotime($this->field->value['to_field_value']));

        $enable_time = $this->field->options[0]['enable_time'];

        $view->assign('enable_time', $enable_time);

        $a = explode(' ', $this->field->value['from_field_value']);
        $b = explode(':', $a[1]);
        $time_h = ($b[0] == '') ? '00' : $b[0];
        $view->assign('from_time_h', $time_h);
        $time_m = ($b[1] == '') ? '00' : $b[1];
        $view->assign('from_time_m', $time_m);
        $time_s = ($b[2] == '') ? '00' : $b[2];
        $view->assign('from_time_s', $time_s);
        
        $a = explode(' ', $this->field->value['to_field_value']);
        $b = explode(':', $a[1]);
        $time_h = ($b[0] == '') ? '00' : $b[0];
        $view->assign('to_time_h', $time_h);
        $time_m = ($b[1] == '') ? '00' : $b[1];
        $view->assign('to_time_m', $time_m);
        $time_s = ($b[2] == '') ? '00' : $b[2];
        $view->assign('to_time_s', $time_s);

        if ($view->template_exists('content_fields/fields/' . $this->field->type . '/field_input-' . $this->field->seo_name . '.tpl')) {
        	$template = 'content_fields/fields/' . $this->field->type . '/field_input-' . $this->field->seo_name . '.tpl';
        } else {
        	$template = 'content_fields/fields/' . $this->field->type . '/field_input.tpl';
        }
        return $view->fetch($template);
    }
    
    public function renderDataOutput($view_type)
    {
    	$CI = &get_instance();

        if (!empty($this->field->options))
        	$format = $this->field->options[0]['format'];
        else
        	$format = 'd.m.Y H:i:s';
		if (!empty($this->field->value['from_field_value']) || !empty($this->field->value['to_field_value'])) {
			if ($this->field->value['from_field_value'] != '0000-00-00 00:00:00') {
	        	$from_value = date($format, strtotime($this->field->value['from_field_value']));
			} else {
				$from_value = '';
			}
			if ($this->field->value['to_field_value'] != '9999-12-31 00:00:00') {
	        	$to_value = date($format, strtotime($this->field->value['to_field_value']));
	        } else {
				$to_value = '';
			}

	        if (!$enable_time) {
	        	$from_value = str_replace(' 00:00:00', '', $from_value);
	        	$to_value = str_replace(' 00:00:00', '', $to_value);
	        }
		} else {
			$from_value = '';
			$to_value = '';
		}

        $view = $CI->load->view();
        $view->assign('field', $this->field);
        $view->assign('from_value', $from_value);
        $view->assign('to_value', $to_value);
        
        // Find the most relevant template, according to view type and field seo name
        if ($view->template_exists('content_fields/fields/' . $this->field->type . '/field_output-' . $view_type . '-' . $this->field->seo_name . '.tpl')) {
        	$template = 'content_fields/fields/' . $this->field->type . '/field_output-' . $view_type . '-' . $this->field->seo_name . '.tpl';
        } elseif ($view->template_exists('content_fields/fields/' . $this->field->type . '/field_output-' . $view_type . '.tpl')) {
        	$template = 'content_fields/fields/' . $this->field->type . '/field_output-' . $view_type . '.tpl';
        } else {
        	$template = 'content_fields/fields/' . $this->field->type . '/field_output.tpl';
        }
        return $view->fetch($template);
    }
    
    public function getValueAsString($glue = ' - ')
    {
    	if (!empty($this->field->options))
        	$format = $this->field->options[0]['format'];
        else
        	$format = 'd.m.Y H:i:s';
		if (!empty($this->field->value['from_field_value']) || !empty($this->field->value['to_field_value'])) {
			if ($this->field->value['from_field_value'] != '0000-00-00 00:00:00') {
	        	$from_value = date($format, strtotime($this->field->value['from_field_value']));
			} else {
				$from_value = '';
			}
			if ($this->field->value['to_field_value'] != '9999-12-31 00:00:00') {
	        	$to_value = date($format, strtotime($this->field->value['to_field_value']));
	        } else {
				$to_value = '';
			}

	        if (!$enable_time) {
	        	$from_value = str_replace(' 00:00:00', '', $from_value);
	        	$to_value = str_replace(' 00:00:00', '', $to_value);
	        }
		} else {
			$from_value = '';
			$to_value = '';
		}
		
		return $from_value . $glue . $to_value;
    }

    public function validate($form_validation)
    {
    	$CI = &get_instance();

    	$form_validation->set_rules('from_' . $this->field->seo_name, LANG_FROM_DATERANGE . " " . $this->field->name, 'max_length[255]');
    	$form_validation->set_rules('from_tmstmp_' . $this->field->seo_name, LANG_FROM_DATERANGE . " " . $this->field->name);
    	$form_validation->set_rules('from_h_' . $this->field->seo_name, $this->field->name, 'integer');
    	$form_validation->set_rules('from_m_' . $this->field->seo_name, $this->field->name, 'integer');
    	$form_validation->set_rules('from_s_' . $this->field->seo_name, $this->field->name, 'integer');
    	
    	$form_validation->set_rules('to_' . $this->field->seo_name, LANG_TO_DATERANGE . " " . $this->field->name, 'max_length[255]');
    	$form_validation->set_rules('to_tmstmp_' . $this->field->seo_name, LANG_TO_DATERANGE . " " . $this->field->name);
    	$form_validation->set_rules('to_h_' . $this->field->seo_name, $this->field->name, 'integer');
    	$form_validation->set_rules('to_m_' . $this->field->seo_name, $this->field->name, 'integer');
    	$form_validation->set_rules('to_s_' . $this->field->seo_name, $this->field->name, 'integer');

    	// Nothing was filled, but required
    	if ($this->field->required && (!$_POST['from_' . $this->field->seo_name] && !$_POST['to_' . $this->field->seo_name])) {
    		$form_validation->_error_array['from_' . $this->field->seo_name] = "Fields '" . LANG_FROM_DATERANGE . " " . $this->field->name . "' or '" . LANG_TO_DATERANGE . " " . $this->field->name . "' must be filled in!";
    	}
    	
    	/*$form->checkString('from_tmstmp_' . $this->field->seo_name, $this->field->name, 255, $this->field->required);
    	$form->checkDigit('from_h_' . $this->field->seo_name, $this->field->name, 23, false, 0);
    	$form->checkDigit('from_m_' . $this->field->seo_name, $this->field->name, 59, false, 0);
    	$form->checkDigit('from_s_' . $this->field->seo_name, $this->field->name, 59, false, 0);
    	
    	$form->checkString('to_tmstmp_' . $this->field->seo_name, $this->field->name, 255, $this->field->required);
    	$form->checkDigit('to_h_' . $this->field->seo_name, $this->field->name, 23, false, 0);
    	$form->checkDigit('to_m_' . $this->field->seo_name, $this->field->name, 59, false, 0);
    	$form->checkDigit('to_s_' . $this->field->seo_name, $this->field->name, 59, false, 0);
    	
    	if ($form->isValid()) {
    		$from_time_h = $form->result['from_h_' . $this->field->seo_name];
    		$from_time_m = $form->result['from_m_' . $this->field->seo_name];
    		$from_time_s = $form->result['from_s_' . $this->field->seo_name];

    		$from_time_h = ($from_time_h == '') ? '00' : $from_time_h;
    		$from_time_m = ($from_time_m == '') ? '00' : $from_time_m;
    		$from_time_s = ($from_time_s == '') ? '00' : $from_time_s;

    		if ($form->result['from_tmstmp_' . $this->field->seo_name]) {
	    		$from_date_time = date('Y-m-d', $form->result['from_tmstmp_' . $this->field->seo_name]) . ' ' . $from_time_h . ':' . $from_time_m . ':' . $from_time_s;
		    	$form->result['from_field_' . $this->field->seo_name] = $from_date_time;
    		}


	    	$to_time_h = $form->result['to_h_' . $this->field->seo_name];
    		$to_time_m = $form->result['to_m_' . $this->field->seo_name];
    		$to_time_s = $form->result['to_s_' . $this->field->seo_name];

    		$to_time_h = ($to_time_h == '') ? '00' : $to_time_h;
    		$to_time_m = ($to_time_m == '') ? '00' : $to_time_m;
    		$to_time_s = ($to_time_s == '') ? '00' : $to_time_s;

    		if ($form->result['to_tmstmp_' . $this->field->seo_name]) {
	    		$to_date_time = date('Y-m-d', $form->result['to_tmstmp_' . $this->field->seo_name]) . ' ' . $to_time_h . ':' . $to_time_m . ':' . $to_time_s;
		    	$form->result['to_field_' . $this->field->seo_name] = $to_date_time;
    		}
    	}*/
    }

    public function configurationPage()
    {
    	$CI = &get_instance();

        if ($CI->input->post('submit')) {
            $CI->form_validation->set_rules('id', LANG_FIELD_ID, 'required');
            $CI->form_validation->set_rules('format', LANG_DATETIME_FORMAT, 'required');
            $CI->form_validation->set_rules('enable_time', LANG_ENABLE_TIME, 'is_checked');

            if ($CI->form_validation->run() !== FALSE) {
				if ($this->saveOptionsByFieldId($CI->form_validation->result_array())) {
					// Clean cache
					$CI->cache->clean(Zend_Cache::CLEANING_MODE_MATCHING_ANY_TAG, array('content_fields', 'search_block'));

					$CI->setSuccess(LANG_FIELD_CONFIG_SAVE_SUCCESS);
					redirect('admin/fields/');
				}
			} else {
	            $options[0]['format'] = $CI->form_validation->set_value('format');
				$options[0]['enable_time'] = $CI->form_validation->set_value('enable_time');
			}
        } else {
        	$options = $this->field->options;
        }

        $view  = new view;
        $view->assign('field', $this->field);
        $view->assign('format', $options[0]['format']);
        $view->assign('enable_time', $options[0]['enable_time']);
        $view->assign('last_page', $CI->session->userdata('last_page'));
        $view->display('content_fields/fields/' . $this->field->type . '/field_configure.tpl');
	}

	public function saveOptionsByFieldId($result)
	{
		$CI = &get_instance();

		$CI->content_fields->db->set('field_id', $this->field->id);
		$CI->content_fields->db->set('format', $result['format']);
		$CI->content_fields->db->set('enable_time', $result['enable_time']);
		return $CI->content_fields->db->on_duplicate_insert('content_fields_type_datetimerange');
	}
	
	public function getDefaultOptions()
	{
		$options[0]['format'] = 'd.m.Y H:i:s';
		$options[0]['enable_time'] = 0;
		return $options;
	}
	
	
	// --------------------------------------------------------------------------------------------
	// Search methods
	// --------------------------------------------------------------------------------------------
	public function renderSearch($args)
	{
		$CI = &get_instance();

		$view = $CI->load->view();
		$view->assign('field', $this->field);
		$view->assign('field_index', "search_" . $this->field->seo_name);
		$view->assign('args', $args);
		$mode = 'single';

		if (isset($args["search_" . $this->field->seo_name])) {
			$tmstmp = null;
			// Receives date in unix timestamp and also in 'Y-m-d' formats
	    	if ((strtotime($args["search_" . $this->field->seo_name])) !== FALSE) {
	    		// 'Y-m-d' format
	    		$tmstmp = strtotime($args["search_" . $this->field->seo_name]);
	    	} elseif ((strtotime(date("Y-m-d", $args["search_" . $this->field->seo_name]))) !== FALSE) {
	    		// Timestamp
	    		$tmstmp = $args["search_" . $this->field->seo_name];
	    	}
	    	
	    	if ($tmstmp) {
	    		$view->assign('date', date("Y-m-d", $tmstmp));
	    		$view->assign('date_tmstmp', $tmstmp);
	    	}
		}
		if (isset($args["from_tmstmp_" . $this->field->seo_name])) {
			$tmstmp = null;
			// Receives date in unix timestamp and also in 'Y-m-d' formats
	    	if ((strtotime($args["from_tmstmp_" . $this->field->seo_name])) !== FALSE) {
	    		// 'Y-m-d' format
	    		$tmstmp = strtotime($args["from_tmstmp_" . $this->field->seo_name]);
	    	} elseif ((strtotime(date("Y-m-d", $args["from_tmstmp_" . $this->field->seo_name]))) !== FALSE) {
	    		// Timestamp
	    		$tmstmp = $args["from_tmstmp_" . $this->field->seo_name];
	    	}
	    	
	    	if ($tmstmp) {
	    		$view->assign('from_date', date("Y-m-d", $tmstmp));
	    		$view->assign('from_date_tmstmp', $tmstmp);
	    	}
			
			$mode = 'range';
		}
		if (isset($args["to_tmstmp_" . $this->field->seo_name])) {
			$tmstmp = null;
			// Receives date in unix timestamp and also in 'Y-m-d' formats
	    	if ((strtotime($args["to_tmstmp_" . $this->field->seo_name])) !== FALSE) {
	    		// 'Y-m-d' format
	    		$tmstmp = strtotime($args["to_tmstmp_" . $this->field->seo_name]);
	    	} elseif ((strtotime(date("Y-m-d", $args["to_tmstmp_" . $this->field->seo_name]))) !== FALSE) {
	    		// Timestamp
	    		$tmstmp = $args["to_tmstmp_" . $this->field->seo_name];
	    	}
	    	
	    	if ($tmstmp) {
	    		$view->assign('to_date', date("Y-m-d", $tmstmp));
	    		$view->assign('to_date_tmstmp', $tmstmp);
	    	}
			
			$mode = 'range';
		}
		$view->assign('mode', $mode);

		$view->display('content_fields/search/' . $this->field->type . '/search_input.tpl');
	}
	
	public function validateSearch($args, &$search_url_rebuild)
	{
		$CI = &get_instance();

		if (isset($args["search_" . $this->field->seo_name])) {
			// Receives date in unix timestamp and also in 'Y-m-d' formats
	    	if (($tmstmp = strtotime($args["search_" . $this->field->seo_name])) !== FALSE && strtotime($args["search_" . $this->field->seo_name]) != -1)
	    		$tmstmp = strtotime($args["search_" . $this->field->seo_name]);
	    	else {
				$tmstmp = $args["search_" . $this->field->seo_name];
	    	}

			$CI->db->select('cftd.object_id');
			$CI->db->from('content_fields_type_datetimerange_data AS cftd');
			$CI->db->where('cftd.field_id', $this->field->id);
			$CI->db->where('cftd.custom_name', LISTINGS_LEVEL_GROUP_CUSTOM_NAME);
			$CI->db->where('TO_DAYS(cftd.from_field_value) <= ', 'TO_DAYS("' . date("Y-m-d", $tmstmp) . '")', false);
			$CI->db->where('TO_DAYS(cftd.to_field_value) >= ', 'TO_DAYS("' . date("Y-m-d", $tmstmp) . '")', false);

			$search_url_rebuild .= "search_" . $this->field->seo_name . '/' . $args["search_" . $this->field->seo_name] . '/';

			$sql = $CI->db->_compile_select();
			$CI->db->_reset_select();
			return array('AND' => str_replace("\n"," ",$sql));
		}

		if (isset($args["from_tmstmp_" . $this->field->seo_name]) || isset($args["to_tmstmp_" . $this->field->seo_name])) {
			if (isset($args["from_tmstmp_" . $this->field->seo_name])) {
				// Receives date in unix timestamp and also in 'Y-m-d' formats
		    	if (($from_tmstmp = strtotime($args["from_tmstmp_" . $this->field->seo_name])) !== FALSE && strtotime($args["from_tmstmp_" . $this->field->seo_name]) != -1)
		    		$from_tmstmp = strtotime($args["from_tmstmp_" . $this->field->seo_name]);
		    	else {
					$from_tmstmp = $args["from_tmstmp_" . $this->field->seo_name];
		    	}
			} else {
				$from_tmstmp = '';
			}
			if (isset($args["to_tmstmp_" . $this->field->seo_name])) {
				// Receives date in unix timestamp and also in 'Y-m-d' formats
		    	if (($to_tmstmp = strtotime($args["to_tmstmp_" . $this->field->seo_name])) !== FALSE && strtotime($args["to_tmstmp_" . $this->field->seo_name]) != -1)
		    		$to_tmstmp = strtotime($args["to_tmstmp_" . $this->field->seo_name]);
		    	else {
					$to_tmstmp = $args["to_tmstmp_" . $this->field->seo_name];
		    	}
			} else {
				$to_tmstmp = '';
			}

			$CI->db->select('cftd.object_id');
			$CI->db->from('content_fields_type_datetimerange_data AS cftd');
			$CI->db->where('cftd.field_id', $this->field->id);
			$CI->db->where('cftd.custom_name', LISTINGS_LEVEL_GROUP_CUSTOM_NAME);
			$where = '';
			if ($from_tmstmp != '') {
				$where .= 'TO_DAYS(cftd.to_field_value) >= TO_DAYS("' . date("Y-m-d", $from_tmstmp) . '")';
				$search_url_rebuild .= "from_tmstmp_" . $this->field->seo_name . '/' . $args["from_tmstmp_" . $this->field->seo_name] . '/';
			}
			if ($to_tmstmp != '') {
				if ($from_tmstmp != '') {
					$where .= ' AND ';
				}
				$where .= 'TO_DAYS(cftd.from_field_value) <= TO_DAYS("' . date("Y-m-d", $to_tmstmp) . '")';
				$search_url_rebuild .= "to_tmstmp_" . $this->field->seo_name . '/' . $args["to_tmstmp_" . $this->field->seo_name] . '/';
			}
			$CI->db->where($where);

			$sql = $CI->db->_compile_select();
			$CI->db->_reset_select();
			return array('AND' => str_replace("\n"," ",$sql));
		}
	}
}
?>