<?php
include_once(MODULES_PATH . 'facebook/classes/facebook.php');

function fcb_login($CI)
{
	$CI->load->model('authorization', 'authorization');
	if ($CI->authorization->checkAuthorization() === FALSE && !$CI->input->post('submit')) {
		$user_info = fcb_getUserInfo();

		if ($user_info && isset($user_info[0]['email']) && $user_info[0]['email']) {
			$CI->load->model('facebook', 'facebook');
			if (!$user_array = $CI->facebook->getFcbUser($user_info['uid'])) {
				$CI->facebook->insertFcbUser($user_info[0]);
			} else {
				$CI->facebook->updateFcbUser($user_info[0]);
			}
			$user = $CI->authorization->setAuthorization($CI->facebook->getFcbUser($user_info['uid']));

			//redirect(HOME_PAGE);
			header("Cache-Control: no-cache");
		}
	}
}

function fcb_getUserInfo($uid = null)
{
	$system_settings = registry::get('system_settings');
	//$url = parse_url(site_url());
	
	if ($uid) {
		$app_id = $system_settings['facebook_app_id'];
	} else {
		$app_id = $system_settings['facebook_api_key'];
	}

	$facebook = new Facebook(array(
	  'appId'  => $app_id,
	  'secret' => $system_settings['facebook_app_secret'],
	  'cookie' => true,
	  //'domain' => $url['host'],
	));

	if (is_null($uid)) {
		$session = $facebook->getSession();
		if ($session)
			$uid = $facebook->getUser();
		else 
			return false;
	} else {
		$facebook->getSession();
	}

	$param  =   array(
		'method'     => 'users.getinfo',
		'uids'       => $uid,
		'fields'     => 'uid, name, email, pic',
		'callback'   => ''
	);
	$user_info = $facebook->api($param);
	$user_info['uid'] = $uid;

	return $user_info;
}

function fcb_logout($CI)
{
	$system_settings = registry::get('system_settings');
	$url = parse_url(site_url());

	$facebook = new Facebook(array(
		'appId'  => $system_settings['facebook_api_key'],
		//'appId'  => $system_settings['facebook_app_id'],
		'secret' => $system_settings['facebook_app_secret'],
		'cookie' => true,
		//'domain' => $url['host'],
	));
	$session = $facebook->getSession();

	if ($session) {
		$logoutUrl = $facebook->getLogoutUrl();
		//$facebook->setSession(null);
		
		$cookieName = 'fbs_'.$system_settings['facebook_api_key'];
		$host = str_replace('www.', '', $url['host']);

		setcookie($cookieName, 'deleted', time()-83600, '/', $host);
		setcookie($cookieName, 'deleted', time()-83600, '/', '.'.$host);
		setcookie($cookieName, 'deleted', time()-83600, '/', '.www.'.$host);
		setcookie($cookieName, 'deleted', time()-83600, '/', 'www.'.$host);
		delete_cookie($cookieName);

		redirect($logoutUrl);
	}
}

function fcb_login_btn($CI)
{
	$system_settings = registry::get('system_settings');
	if ($system_settings['facebook_api_key'] && $system_settings['facebook_app_secret']) {
		$view = $CI->load->view();
		return $view->fetch('facebook/fcb_login_btn.tpl');
	}
}

function fcb_connect_js($CI)
{
	$system_settings = registry::get('system_settings');
	if ($system_settings['facebook_api_key'] && $system_settings['facebook_app_secret']) {
		$view = $CI->load->view();
		return $view->fetch('facebook/fcb_connect_js.tpl');
	}
}

function fcb_systemSettingsPage($CI)
{
	$system_settings = registry::get('system_settings');

	$view = $CI->load->view();
	$view->assign('system_settings', $system_settings);
	return $view->fetch('facebook/fcb_settings.tpl');
}
function fcb_handleSystemSettings($CI)
{
	if ($CI->input->post('submit')) {
		$CI->form_validation->set_rules('facebook_api_key', LANG_FACEBOOK_API_KEY, 'max_length[255]');
		$CI->form_validation->set_rules('facebook_app_id', LANG_FACEBOOK_APP_ID, 'max_length[255]');
		$CI->form_validation->set_rules('facebook_app_secret', LANG_FACEBOOK_APP_SECRET, 'max_length[255]');
	}
}
?>