<?php

class blockClass
{
	protected $params = array();
	protected $wrapper_object = null;

	/**
	 * wrapper object builds like   wrapper_`block_name`_`view_name`.class.php
	 *
	 * @param array $params
	 */
	public function __construct($params)
	{
		$this->params = $params;
		
		if (!isset($this->params['items_array'])) {
			$this->params['items_array'] = $this->getItems();
		}
		
		// --------------------------------------------------------------------------------------------
		// Execute special wrapper class or default
		// --------------------------------------------------------------------------------------------
		if (is_file(MODULES_PATH . 'frontend/classes/wrappers/wrapper_' . $this->params['block_type'] . '_' . $this->params['view_name'] . '.class.php')) {
			include_once(MODULES_PATH . 'frontend/classes/wrappers/wrapper.class.php');
			include_once(MODULES_PATH . 'frontend/classes/wrappers/wrapper_' . $this->params['block_type'] . '_' . $this->params['view_name'] . '.class.php');
			$class = $this->params['block_type'] . ucfirst($this->params['view_name']) . 'WrapperClass';
			$this->wrapper_object = new $class($this->params);
		}
	}
	
	/**
	 * when items array doesn't passed into the block - it must be extracted here
	 * will be rewriten in children
	 *
	 */
	protected function getItems()
	{
		return $this->params['items_array'];
	}
	
	/**
	 * block contains listings wrapper, listings wrapper contains listings
	 * block -> listings wrapper -> listings
	 *
	 * @return html
	 */
	public function render()
	{
		$CI = &get_instance();
		$block = $CI->load->view();

		// --------------------------------------------------------------------------------------------
		// Render special template or default
		// --------------------------------------------------------------------------------------------
		if (isset($this->params['block_template']) && $block->template_exists('frontend/blocks/' . $this->params['block_template'])) {
        	$block_template = 'frontend/blocks/' . $this->params['block_template'];
        } else {
        	$block_template = 'frontend/blocks/default.tpl';
        }
        // --------------------------------------------------------------------------------------------

		if ($this->wrapper_object)
			$block->assign('wrapper_object', $this->wrapper_object);
		$block->assign($this->params);
		return $block->fetch($block_template);
	}
}
?>