<?php

class categoriesBlockClass extends blockClass
{
	/**
	 * when items array doesn't passed into the block - it must be extracted here
	 *
	 */
	public function getItems()
	{
		$CI = &get_instance();
		$CI->load->model('categories', 'categories');

		if (isset($this->params['type'])) {
			$type = $this->params['type'];
			if (is_object($type))
				$type_id = $type->id;
			else {
				$type_id = $type;
				$CI->load->model('types', 'types_levels');
				$type = $CI->types->getTypeById($type_id);
			}
		} else {
			$type_id = 0;
		}
		if (isset($this->params['from_category_id'])) {
			$from_category_id = $this->params['from_category_id'];
		} else {
			$from_category_id = 0;
		}
		if (isset($this->params['max_depth'])) {
			$max_depth = $this->params['max_depth'];
		} else {
			$max_depth = 'max';
		}

		if ($type->categories_type == 'global')
			$type_id = 0;

	    if (!$cache = $CI->cache->load('categories_' . $type_id)) {
	    	$CI->categories->setTypeId($type_id);
			$categories_array = $CI->categories->selectCategoriesFromDB();
			$categories_tree = array();
			$CI->categories->buildCategoriesTree($categories_array, $categories_tree, $from_category_id, $max_depth);
			$CI->cache->save(array($categories_tree, $categories_array), 'categories_' . $type_id, array('categories_' . $type_id));
	    } else {
	    	list($categories_tree, $categories_array) = $cache;
	    }
	    $this->params['categories_tree'] = $categories_tree;

		if (!$type || $type->categories_type == 'global') {
			$local_type_seo_name = null;
		} else {
			$local_type_seo_name = $type->seo_name;
		}
		$this->params['local_type_seo_name'] = $local_type_seo_name;
	}
}
?>