<?php
include_once(MODULES_PATH . 'content_fields/classes/search_content_fields.class.php');

class listingsBlockClass extends blockClass
{
	/**
	 * when items array doesn't passed into the block - it must be extracted here
	 *
	 */
	protected function getItems()
	{
		/* Params:
		
		what_search - string,
		what_match - any/exact,
		where_search - string,
		where_radius - int,
		search_type - ID/obj,
		search_category - id1,id2,id3,id4,.../array/ID/obj/seo name
		search_location - ID/obj/seo name
		search_owner - login/ID
		search_status - 1: active, 2: blocked, 3: suspended, 4: unapproved, 5: not paid
		search_users_status - 1: unverified, 2: active, 3: blocked
		search_creation_date - timestamp/'Y-m-d'
		search_from_creation_date - timestamp/'Y-m-d'
		search_to_creation_date - timestamp/'Y-m-d'
		view_name - full/semitable/short
		view_format - int/'int*int'
		orderby [l.id]
		direction [desc]
		only_with_logos=boolean
		fully_load - boolean

		limit [10] - int
		*/
		
		$CI = &get_instance();

		if (isset($this->params['search_type_id'])) {
			$search_type_id = $this->params['search_type_id'];

			$CI->load->model('types', 'types_levels');
			$current_type = $CI->types->getTypeById($search_type_id);
			if ($current_type->search_type == 'global')
				$search_custom_group_id = 0;
			else
				$search_custom_group_id = $search_type_id;
		} else {
			$search_custom_group_id = 0;
			$current_type = null;
		}
		
		if (isset($this->params['fully_load'])) {
			$fully_load = $this->params['fully_load'];
		} else {
			$fully_load = true;
		}

		if (isset($this->params['orderby'])) {
			$orderby = $this->params['orderby'];
		} else {
			$orderby = 'l.id';
		}
		if (isset($this->params['direction'])) {
			$direction = $this->params['direction'];
		} else {
			$direction = 'desc';
		}

		// --------------------------------------------------------------------------------------------
		$CI->load->model('categories', 'categories');
		if (isset($search_type_id) && $current_type->categories_type == 'local') {
			// Local categories
			$CI->categories->setTypeId($search_type_id);
		}
		$categories_array = $CI->categories->selectCategoriesFromDB();
		// --------------------------------------------------------------------------------------------
		
		// --------------------------------------------------------------------------------------------
		// Build search content fields block
		if ($search_custom_group_id == 0) {
			$group_name = GLOBAL_SEARCH_GROUP_CUSTOM_NAME;
		} else {
			$group_name = LOCAL_SEARCH_GROUP_CUSTOM_NAME;
		}
		$search_fields = new searchContentFields($group_name, $search_custom_group_id);
		$search_sql_array = $search_fields->validateSearch($this->params, 'true', $search_url_rebuild);
		// --------------------------------------------------------------------------------------------
		
		$paginator_attrs['args'] = $this->params;
		if (isset($this->params['limit']))
			$paginator_attrs['num_per_page'] = $this->params['limit'];
		else 
			$paginator_attrs['num_per_page'] = 10;
		
		$CI->load->library('pagination', $paginator_attrs);
		$CI->load->model('listings', 'listings');
		$CI->pagination->setNumPerPage($paginator_attrs['num_per_page']);
		$CI->listings->setPaginator($CI->pagination);
		return $CI->listings->selectListings($this->params, $orderby, $direction, $search_sql_array, $categories_array, $fully_load);
	}
}
?>