<?php

class locationGeoname
{
	public function geonames_request($query, $return = 'geoname')
	{
		$system_settings = registry::get('system_settings');
        if (@$maps_key = $system_settings['maps_key']) {
	        $fullUrl = sprintf("http://maps.google.com/maps/geo?q=%s&key=%s&hl=en&output=json", urlencode($query), $maps_key);
			$ch = curl_init($fullUrl);
			curl_setopt($ch, CURLOPT_HEADER, 0);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch, CURLOPT_ENCODING, 'UTF-8');
			$response = curl_exec($ch);
			$ret = json_decode( $response, true );
			curl_close($ch);
			if($ret && $ret["Status"]["code"] == 200) {
				if ($return == 'coordinates') {
					return $ret["Placemark"][0]["Point"]["coordinates"];
				} elseif ($return == 'geoname') {
					$geocoded_name = '';
					if (isset($ret["Placemark"][0]["AddressDetails"]["Country"]) && isset($ret["Placemark"][0]["AddressDetails"]["Country"]["CountryName"])) {
						// Country
						$geocoded_name = $ret["Placemark"][0]["AddressDetails"]["Country"]["CountryName"];
						if (isset($ret["Placemark"][0]["AddressDetails"]["Country"]["AdministrativeArea"])) {
							// State/Region
							$geocoded_name = $ret["Placemark"][0]["AddressDetails"]["Country"]["AdministrativeArea"]["AdministrativeAreaName"] . ', ' . $geocoded_name;
							if (isset($ret["Placemark"][0]["AddressDetails"]["Country"]["AdministrativeArea"]["Locality"])) {
								// City
								$geocoded_name = $ret["Placemark"][0]["AddressDetails"]["Country"]["AdministrativeArea"]["Locality"]["LocalityName"] . ', ' . $geocoded_name;
							} elseif (isset($ret["Placemark"][0]["AddressDetails"]["Country"]["AdministrativeArea"]["SubAdministrativeArea"])) {
								if (isset($ret["Placemark"][0]["AddressDetails"]["Country"]["AdministrativeArea"]["SubAdministrativeArea"]["SubAdministrativeAreaName"])) {
									// Province
									$geocoded_name = $ret["Placemark"][0]["AddressDetails"]["Country"]["AdministrativeArea"]["SubAdministrativeArea"]["SubAdministrativeAreaName"] . ', ' . $geocoded_name;
								}
								if (isset($ret["Placemark"][0]["AddressDetails"]["Country"]["AdministrativeArea"]["SubAdministrativeArea"]["Locality"])) {
									// City/town
									$geocoded_name = $ret["Placemark"][0]["AddressDetails"]["Country"]["AdministrativeArea"]["SubAdministrativeArea"]["Locality"]["LocalityName"] . ', ' . $geocoded_name;
									if (isset($ret["Placemark"][0]["AddressDetails"]["Country"]["AdministrativeArea"]["SubAdministrativeArea"]["Locality"]["DependentLocality"])) {
										// City/town district
										$geocoded_name = $ret["Placemark"][0]["AddressDetails"]["Country"]["AdministrativeArea"]["SubAdministrativeArea"]["Locality"]["DependentLocality"]["DependentLocalityName"] . ', ' . $geocoded_name;
									}
								}
							}
						} elseif (isset($ret["Placemark"][0]["AddressDetails"]["Country"]["SubAdministrativeArea"])) {
							if (isset($ret["Placemark"][0]["AddressDetails"]["Country"]["SubAdministrativeArea"]["SubAdministrativeAreaName"])) {
								// Province
								$geocoded_name = $ret["Placemark"][0]["AddressDetails"]["Country"]["SubAdministrativeArea"]["SubAdministrativeAreaName"] . ', ' . $geocoded_name;
							}
							if (isset($ret["Placemark"][0]["AddressDetails"]["Country"]["SubAdministrativeArea"]["Locality"])) {
								// City/town
								$geocoded_name = $ret["Placemark"][0]["AddressDetails"]["Country"]["SubAdministrativeArea"]["Locality"]["LocalityName"] . ', ' . $geocoded_name;
							}
							if (isset($ret["Placemark"][0]["AddressDetails"]["Country"]["SubAdministrativeArea"]["Locality"]["DependentLocality"])) {
								// City/town district
								$geocoded_name = $ret["Placemark"][0]["AddressDetails"]["Country"]["SubAdministrativeArea"]["Locality"]["DependentLocality"]["DependentLocalityName"] . ', ' . $geocoded_name;
							}
						}
					}
					return $geocoded_name;
				} elseif ($return == 'address') {
					return $ret["Placemark"][0]["address"];
				}
			} else {
				return '';
			}
        } else {
        	return '';
        }
	}
}
?>