<?php
include_once(MODULES_PATH . 'google_maps/classes/location_geoname.class.php');

class searchCore
{
	private $args;

	public function setArgs($args)
	{
		$this->args = $args;
	}
	
	public function processWhat()
	{
		if (isset($this->args['what_search'])) {
			if (!isset($this->args['what_search'])) {
				$what_match = 'any';
			} else {
				$what_match = $this->args['what_match'];
			}
			$listings_result = array();
			if ($what_match == 'any')
				$what_array = array_values(array_filter(explode(' ', mb_str_replace(array(',','.',':',';','/','\\','-'), ' ', urldecode(html_entity_decode($this->args['what_search']))))));
			else 
				$what_array = array(urldecode(html_entity_decode($this->args['what_search'])));

			array_walk($what_array, 'trim');
			
			$CI = &get_instance();
			
			// --------------------------------------------------------------------------------------------
			// Search for any inclusions of words
			// --------------------------------------------------------------------------------------------
			$CI->db->distinct();
			$CI->db->select('l.id');
			$CI->db->select('l.title');
			$CI->db->select('l.listing_description');
			//$CI->db->select('l.listing_keywords');
			$CI->db->from('listings AS l');
			foreach ($what_array AS $word) {
				$CI->db->or_like('l.title', $word, 'both');
				$CI->db->or_like('l.listing_description', $word, 'both');
				//$CI->db->or_like('l.listing_keywords', $word, 'both');
			}
			$query = $CI->db->get();
			$listings = $query->result_array();
			// --------------------------------------------------------------------------------------------

			if ($what_match == 'any') {
				// --------------------------------------------------------------------------------------------
				// Get all possible variants of entered words
				// using binary model of array
				// --------------------------------------------------------------------------------------------
				$words_variants = array();
				$variants_count = pow(2, count($what_array))-1;
				for ($i=1; $i<=$variants_count; $i++) {
					$_variant_bin = decbin($i);
					$variant_bin = decbin($i);
					// Everywhere must be count($where_array) length of string
					for ($c=0; $c<(count($what_array)-strlen($_variant_bin)); $c++) {
						$variant_bin = '0'.$variant_bin;
					}
					$this_variant = array();
					for ($j=0; $j<strlen($variant_bin); $j++) {
						if ($variant_bin[$j] == '1') {
							$this_variant[] = $what_array[$j];
						}
					}
					$words_variants[] = $this_variant;
				}
				// --------------------------------------------------------------------------------------------
				// Find additional combination of words
				// --------------------------------------------------------------------------------------------
				foreach ($words_variants AS $variant) {
					if (count($variant) != 1) {
						$_variants = array();
						$count_variants = 0;
						for ($i=count($variant)-1; $i>0; $i--) {
							$count_variants += $i;
						}
						$count_variants++;
						while (count($_variants)<$count_variants) {
							$this_variant = $variant;
							shuffle($this_variant);
							if (!in_array($this_variant, $_variants)) {
								$_variants[] = $this_variant;
								if (!in_array($this_variant, $words_variants))
									$words_variants[] = $this_variant;
							}
						}
					}
				}
				// --------------------------------------------------------------------------------------------
			} else {
				$words_variants = array($what_array);
			}
				
			// --------------------------------------------------------------------------------------------
			foreach ($listings AS $key=>$listing_row) {
				$weight = 0;
				foreach ($words_variants AS $variant) {
					$variant_str = mb_strtolower(implode(' ', $variant));
					$title = implode(' ', explodeWords(array(" ",",",".",":",";"), mb_strtolower($listing_row['title'])));
					$listing_description = implode(' ', explodeWords(array(" ",",",".",":",";"), mb_strtolower($listing_row['listing_description'])));
					//$listing_keywords = implode(' ', explodeWords(array(" ",",",".",":",";"), mb_strtolower($listing_row['listing_keywords'])));

					// if exact match of variant - increment weight on 2
					if ($title == $variant_str)
						$weight += 2;
					// or count variant of whole words
					elseif ($pcount = mb_substr_count($title, ' '.$variant_str.' '))
						$weight += $pcount;
					// or from string start
					elseif (mb_strpos($title, $variant_str.' ', 0) === 0)
						$weight += 1;
					// or at the end
					elseif (@mb_strpos($title, ' '.$variant_str, mb_strlen($title)-mb_strlen($variant_str)-1) !== FALSE)
						$weight += 1;

					// if exact match of variant - increment weight on 2
					if ($listing_description == $variant_str)
						$weight += 2;
					// or count variant of whole words
					elseif ($pcount = mb_substr_count($listing_description, ' '.$variant_str.' '))
						$weight += $pcount;
					// or from string start
					elseif (mb_strpos($listing_description, $variant_str.' ', 0) === 0)
						$weight += 1;
					// or at the end
					elseif (@mb_strpos($listing_description, ' '.$variant_str, mb_strlen($listing_description)-mb_strlen($variant_str)-1) !== FALSE)
						$weight += 1;

					// if exact match of variant - increment weight on 2
					/*if ($listing_keywords == $variant_str)
						$weight += 2;
					// or count variant of whole words
					elseif ($pcount = mb_substr_count($listing_keywords, ' '.$variant_str.' '))
						$weight += $pcount;
					// or from string start
					elseif (mb_strpos($listing_keywords, $variant_str.' ', 0) === 0)
						$weight += 1;
					// or at the end
					elseif (@mb_strpos($listing_keywords, ' '.$variant_str, mb_strlen($listing_keywords)-mb_strlen($variant_str)-1) !== FALSE)
						$weight += 1;*/
				}
				$listings[$key]['weight'] = $weight;
			}
			// --------------------------------------------------------------------------------------------
			
			foreach ($listings AS $key=>$listing_row) {
				$listings_result[$listing_row['weight']][] = $listing_row;
			}

			krsort($listings_result);


			unset($listings_result[0]);
			//unset($listings_result[1]);
			
			// --------------------------------------------------------------------------------------------
			// --------------------------------------------------------------------------------------------
			/*foreach ($listings_result AS $weight=>$listings1) {
				foreach ($listings1 AS $listing_row) {
					var_dump($weight);
					var_dump($listing_row['title']);
					echo "<br />";
					echo "<br />";
				}
			}*/
			// --------------------------------------------------------------------------------------------
			// --------------------------------------------------------------------------------------------

			
			// Initial array('null') in order to prevent error in sql query 'WHERE l.id IN ()',
			// when nothing was found
			$listings_ids = array('null');
			foreach ($listings_result AS $weight=>$listings1) {
				foreach ($listings1 AS $listing_row) {
					$listings_ids[] = $listing_row['id'];
				}
			}
			$listings_ids = array_unique($listings_ids);
			return $listings_ids;
		} else {
			return false;
		}
	}
	
	public function processWhere()
	{
		if (isset($this->args['where_search'])) {
			$locations_zip = array();
			$locations_inc = array();
			$locations_geo = array();
			$locations_result = array();
			
			$possible_connectors = array(',','.',':',';','/','\\','-');
			
			$where_array = array_values(array_filter(explode(' ', mb_str_replace($possible_connectors, ' ', urldecode(html_entity_decode($this->args['where_search']))))));

			array_walk($where_array, 'trim');
			
			// Also add space
			$possible_connectors[] = ' ';
			$words_with_both_connectors = array();
			$words_with_right_connectors = array();
			$words_with_left_connectors = array();
			foreach ($where_array AS $word) {
				foreach ($possible_connectors AS $connector1) {
					foreach ($possible_connectors AS $connector2) {
						$words_with_both_connectors[] = $connector1 . $word . $connector2;
					}
					$words_with_right_connectors[] = $word . $connector1;
					$words_with_left_connectors[] = $connector1 . $word;
				}
			}
			
			$CI = &get_instance();
			
			// --------------------------------------------------------------------------------------------
			// Search for any inclusions of words
			// --------------------------------------------------------------------------------------------
			$CI->db->distinct();
			$CI->db->select('loc.id');
			$CI->db->select('loc.listing_id');
			//$CI->db->select('loc.location AS location');
			$CI->db->select('loc.address_line_1 AS address_line_1');
			$CI->db->from('listings_in_locations AS loc');
			//foreach ($where_array AS $word) {
				foreach ($words_with_both_connectors AS $word)
					$CI->db->or_like('loc.address_line_1', $word, 'both');
				foreach ($words_with_right_connectors AS $word)
					$CI->db->or_like('loc.address_line_1', $word, 'after');
				foreach ($words_with_left_connectors AS $word)
					$CI->db->or_like('loc.address_line_1', $word, 'before');
				//$CI->db->or_like('loc.location', $word, 'both');
			//}
			$query = $CI->db->get();
			$locations_inc = $query->result_array();
			// --------------------------------------------------------------------------------------------
			
			// --------------------------------------------------------------------------------------------
			// Search if zip code matchs words
			// --------------------------------------------------------------------------------------------
			foreach ($where_array AS $word) {
				$CI->db->select('loc.id');
				$CI->db->select('loc.listing_id');
				//$CI->db->select('loc.location AS location');
				$CI->db->select('loc.address_line_1 AS address_line_1');
				$CI->db->from('listings_in_locations AS loc');
				$CI->db->where('zip_or_postal_index', $word);
				$query = $CI->db->get();
				$locations_zip = $query->result_array();
			}
			// --------------------------------------------------------------------------------------------

			if (!$locations_zip) {
				// --------------------------------------------------------------------------------------------
				// Get all possible variants of entered words
				// using binary model of array
				// --------------------------------------------------------------------------------------------
				$words_variants = array();
				$variants_count = pow(2, count($where_array))-1;
				for ($i=1; $i<=$variants_count; $i++) {
					$_variant_bin = decbin($i);
					$variant_bin = decbin($i);
					// Everywhere must be count($where_array) length of string
					for ($c=0; $c<(count($where_array)-strlen($_variant_bin)); $c++) {
						$variant_bin = '0'.$variant_bin;
					}
					$this_variant = array();
					for ($j=0; $j<strlen($variant_bin); $j++) {
						if ($variant_bin[$j] == '1') {
							$this_variant[] = $where_array[$j];
						}
					}
					$words_variants[] = $this_variant;
				}

				// --------------------------------------------------------------------------------------------
		
				// --------------------------------------------------------------------------------------------
				// Find additional combination of words
				// --------------------------------------------------------------------------------------------
				//$geo_words_variants = $words_variants;
				/*foreach ($words_variants AS $variant) {
					if (count($variant) != 1) {
						$_variants = array();
						$count_variants = 0;
						for ($i=count($variant)-1; $i>0; $i--) {
							$count_variants += $i;
						}
						$count_variants++;
						while (count($_variants)<$count_variants) {
							$this_variant = $variant;
							shuffle($this_variant);
							if (!in_array($this_variant, $_variants)) {
								$_variants[] = $this_variant;
								if (!in_array($this_variant, $words_variants))
									$words_variants[] = $this_variant;
							}
						}
					}
				}*/
				// --------------------------------------------------------------------------------------------
				
				
				// --------------------------------------------------------------------------------------------
				foreach ($locations_inc AS $key=>$location_row) {
					$weight = 0;
					foreach ($words_variants AS $variant) {
						$variant_str = mb_strtolower(implode(' ', $variant));
						$address_line_1 = implode(' ', explodeWords(array(" ",",",".",":",";"), mb_strtolower($location_row['address_line_1'])));
						//$location = implode(' ', explodeWords(array(" ",",",".",":",";"), mb_strtolower($location_row['location'])));
						
						// if exact match of variant - increment weight on 2
						if ($address_line_1 == $variant_str)
							$weight += 2;
						// or count variant of whole words
						elseif ($pcount = mb_substr_count($address_line_1, ' '.$variant_str.' '))
							$weight += $pcount;
						// or from string start
						elseif (mb_strpos($address_line_1, $variant_str.' ', 0) === 0)
							$weight += 1;
						// or at the end
						elseif (@mb_strpos($address_line_1, ' '.$variant_str, mb_strlen($address_line_1)-mb_strlen($variant_str)-1) !== FALSE)
							$weight += 1;

						// if exact match of variant - increment weight on 2
						/*if ($location == $variant_str)
							$weight += 2;
						// or count variant of whole words
						elseif ($pcount = mb_substr_count($location, ' '.$variant_str.' '))
							$weight += $pcount;
						// or from string start
						elseif (mb_strpos($location, $variant_str.' ', 0) === 0)
							$weight += 1;
						// or at the end
						elseif (@mb_strpos($location, ' '.$variant_str, mb_strlen($location)-mb_strlen($variant_str)-1) !== FALSE)
							$weight += 1;*/
					}
					if ($weight)
						$locations_inc[$key]['weight'] = $weight;
					else 
						unset($locations_inc[$key]);
				}
				//var_dump($locations_inc);
				
				// --------------------------------------------------------------------------------------------
				
				// --------------------------------------------------------------------------------------------
				// Try to geoname all variants
				// --------------------------------------------------------------------------------------------
				$geocoder = new locationGeoname;
				
				// Check is in 'where' field entered only location without address part
				$original_geocoded_location = $geocoder->geonames_request($this->args['where_search']);
				$original_geocoded_address = $geocoder->geonames_request($this->args['where_search'], 'address');
				$final_geocoded_address = $geocoder->geonames_request($original_geocoded_location, 'address');
				/*var_dump($original_geocoded_location);
				var_dump($original_geocoded_address);
				var_dump($final_geocoded_address);*/
				if ($original_geocoded_address == $final_geocoded_address) {
					// yes, there is only location, no address
					$CI->db->select('loc.id');
					$CI->db->select('loc.listing_id');
					$CI->db->from('listings_in_locations AS loc');
					$CI->db->like('geocoded_name', $original_geocoded_location, 'before');
					$result = $CI->db->get()->result_array();
					foreach ($result AS $row) {
						$row['weight'] = 1;
						$row['geo_weight'] = 1;
						$locations_inc[] = $row;
					}
				} elseif ($original_geocoded_location) {
					// there is location + address
					$CI->db->select('loc.id');
					$CI->db->select('loc.listing_id');
					$CI->db->from('listings_in_locations AS loc');
					$CI->db->like('geocoded_name', $original_geocoded_location, 'before');
					$result = $CI->db->get()->result_array();
					foreach ($locations_inc AS $key=>$location) {
						$exists = false;
						foreach ($result AS $row) {
							if ($location['id'] == $row['id']) {
								$locations_inc[$key]['weight'] += 1;
								$locations_inc[$key]['geo_weight'] = 1;
								$exists = true;
							}
						}
						if (!$exists) {
							if ($locations_inc[$key]['weight'] == 1)
							unset($locations_inc[$key]);
						}
					}
				}
				
				//foreach ($geo_words_variants AS $variant) {
					/*if ($geocoded_name = $geocoder->geonames_request($this->args['where_search'])) {
						//var_dump($geocoded_name);
					//if ($geocoded_name = $geocoder->geonames_request(implode(', ', $variant))) {
						$CI->db->select('loc.id');
						$CI->db->select('loc.listing_id');
						$CI->db->from('listings_in_locations AS loc');
						$CI->db->like('geocoded_name', $geocoded_name, 'before');
						$result = $CI->db->get()->result_array();
						foreach ($locations_inc AS $key=>$location) {
							$exists = false;
							foreach ($result AS $row) {
								if ($location['id'] == $row['id']) {
									$locations_inc[$key]['weight'] += 1;
									$locations_inc[$key]['geo_weight'] = 1;
									$exists = true;
								}
							}
							if (!$exists) {
								unset($locations_inc[$key]);
							}
						}
					}*/
				//}
				// --------------------------------------------------------------------------------------------

				foreach ($locations_inc AS $key=>$location_row) {
					if (isset($location_row['geo_weight']))
						$geo_weight = $location_row['geo_weight'];
					else 
						$geo_weight = 0;
					$locations_result[$location_row['weight']][$geo_weight][] = $location_row;
				}
				/*if (count($where_array) > 1) {
					unset($locations_result[1][1]);
					unset($locations_result[1][0]);
				}*/
				unset($locations_result[0][0]);
				//unset($locations_result[1]);
				//unset($locations_result[2]);

				krsort($locations_result);
				foreach ($locations_result AS $key=>$location1)
					krsort($locations_result[$key]);
				
				/*foreach ($locations_result AS $weight=>$location1) {
					foreach ($location1 AS $geo_weight=>$location2) {
						foreach ($location2 AS $location) {
							var_dump($weight);
							var_dump($geo_weight);
							var_dump($location['listing_id']);
							echo "<br />";
							echo "<br />";
						}
					}
				}*/

				// Initial array('null') in order to prevent error in sql query 'WHERE l.id IN ()',
				// when nothing was found
				$listings_ids = array('null');
				foreach ($locations_result AS $weight=>$location1) {
					foreach ($location1 AS $geo_weight=>$location2) {
						foreach ($location2 AS $location) {
							$listings_ids[] = $location['listing_id'];
						}
					}
				}
				$listings_ids = array_unique($listings_ids);
			} else {
				foreach ($locations_zip AS $location)
					$listings_ids[] = $location['listing_id'];
			}
			return $listings_ids;
		} else {
			return false;
		}
	}
}

// str_len function with mbString functionality
function mb_str_replace($needle, $replacement, $haystack) {
	if (!is_array($needle))
		$needle = array($needle);
	foreach ($needle AS $needle_item) {
		$needle_len = mb_strlen($needle_item);
		$pos = mb_strpos($haystack, $needle_item);
		while (!($pos === false)) {
			$front = mb_substr($haystack, 0, $pos );
			$back  = mb_substr($haystack, $pos + $needle_len);
			$haystack = $front . $replacement . $back;
			$pos = mb_strpos($haystack, $needle_item);
		}
	}
	return $haystack;
}

// Explode a string by different delimiters
function explodeWords($delimiters, $string)
{
    $return_array = Array($string); // The array to return
    $d_count = 0;
    while (isset($delimiters[$d_count])) // Loop to loop through all delimiters
    {
        $new_return_array = Array();
        foreach($return_array as $el_to_split) // Explode all returned elements by the next delimiter
        {
            $put_in_new_return_array = explode($delimiters[$d_count], $el_to_split);
            foreach($put_in_new_return_array as $substr) // Put all the exploded elements in array to return
            {
                $new_return_array[] = trim($substr);
            }
        }
        $return_array = $new_return_array; // Replace the previous return array by the next version
        $d_count++;
    }
    return $return_array; // Return the exploded elements
}
?>