<?php

class predefinedLocation
{
	public $id;
	public $parent_id;
	public $name;
	public $seo_name;
	public $tree_path;
	public $use_as_label;
	public $geocoded_name;
	public $selected;
	
	public function __construct()
	{
		$this->id = 'new';
		$this->parent_id = 'new';
		$this->name = '';
		$this->seo_name = '';
		$this->tree_path = '';
		$this->use_as_label = false;
		$this->geocoded_name = '';
		$this->selected = false;
	}
	
	public function setLocationFromArray($array)
	{
		if (isset($array['id']))
			$this->id = $array['id'];
		if (isset($array['parent_id']))
			$this->parent_id = $array['parent_id'];
		$this->name = $array['name'];
		$this->seo_name = $array['seo_name'];
		if (isset($array['tree_path']))
			$this->tree_path = $array['tree_path'];
		if (isset($array['use_as_label']))
			$this->use_as_label = $array['use_as_label'];
		if (isset($array['geocoded_name']))
			$this->geocoded_name = $array['geocoded_name'];
	}
	
	public function setSelected()
	{
		$this->selected = true;
	}
	
	public function getChainAsArray()
	{
		$CI = &get_instance();
    	$CI->load->model('locations', 'locations_predefined');

		$chain_ids = explode('-', $this->tree_path);
		array_shift($chain_ids);
		
		$chain = array();
		foreach ($chain_ids AS $location_id) {
			if ($location_id) {
				$location = $CI->locations->getLocationById($location_id);
				$chain[] = $location;
			}
		}
		return $chain;
	}
	
	public function getChainAsString($glue = ', ')
	{
		$chain = $this->getChainAsArray();
		$locations = array();
		foreach ($chain AS $location)
			$locations[] = $location->name;
		return implode($glue, array_reverse($locations));
	}
}
?>