<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

// --------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------
/*
|
|
|          TYPICALLY HERE ARE 2 CONFIG OPTIONS YOU NEED TO CHANGE IN THIS FILE
|
|
|--------------------------------------------------------------------------
| Base domain name and subdirectory
|--------------------------------------------------------------------------
|
| URL to your site root. Typically this will be your base URL,
| WITH a trailing slash:
|	$config['base_url'] = "http://www.example.com/";
|
|
| Path to your site in subdirectory also WITH a trailing slash:
|   $config['subdirectory'] = "my_subdir/";
|
| NOTE: if your site is not in subdirectory - leave it empty
|
*/
$config['base_url']	= "http://www.yoursite.com/";
$config['subdirectory']	= "";


// --------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------
/*
|
|
|      If you still can't install the script or it doesn't work as you expect - go to our manual
|      at http://www.salephpscripts.com/manual/
|
|
*/
// --------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------










/*
|--------------------------------------------------------------------------
| Index File
|--------------------------------------------------------------------------
|
| Typically this will be your index.php file, unless you've renamed it to
| something else. If you are using mod_rewrite to remove the page set this
| variable so that it is blank.
|
*/
$config['index_page'] = "";

/*
|--------------------------------------------------------------------------
| URI PROTOCOL
|--------------------------------------------------------------------------
|
| This item determines which server global should be used to retrieve the
| URI string.  The default setting of "AUTO" works for most servers.
| If your links do not seem to work, try one of the other delicious flavors:
|
| 'AUTO'			Default - auto detects
| 'PATH_INFO'		Uses the PATH_INFO
| 'QUERY_STRING'	Uses the QUERY_STRING
| 'REQUEST_URI'		Uses the REQUEST_URI
| 'ORIG_PATH_INFO'	Uses the ORIG_PATH_INFO
|
*/
$config['uri_protocol']	= "REQUEST_URI";

/*
|--------------------------------------------------------------------------
| URL suffix
|--------------------------------------------------------------------------
|
| This option allows you to add a suffix to all URLs generated by CodeIgniter.
| For more information please see the user guide:
|
| http://codeigniter.com/user_guide/general/urls.html
*/

$config['url_suffix'] = "";

/*
|--------------------------------------------------------------------------
| Default Language
|--------------------------------------------------------------------------
|
| This determines which set of language files should be used. Make sure
| there is an available translation if you intend to use something other
| than english.
|
*/
$config['language']	= "english";

// --------------------------------------------------------------------------------------------
/**
 * Default language for all lang constants.
 * 
 * It uses like an extracting columns from DB: 'default_language'_'column name'
 * 
 */
$config['default_language']	= "en";
// --------------------------------------------------------------------------------------------

/*
|--------------------------------------------------------------------------
| Default Character Set
|--------------------------------------------------------------------------
|
| This determines which character set is used by default in various methods
| that require a character set to be provided.
|
*/
$config['charset'] = "UTF-8";

/*
|--------------------------------------------------------------------------
| Enable/Disable System Hooks
|--------------------------------------------------------------------------
|
| If you would like to use the "hooks" feature you must enable it by
| setting this variable to TRUE (boolean).  See the user guide for details.
|
*/
$config['enable_hooks'] = FALSE;


/*
|--------------------------------------------------------------------------
| Class Extension Prefix
|--------------------------------------------------------------------------
|
| This item allows you to set the filename/classname prefix when extending
| native libraries.  For more information please see the user guide:
|
| http://codeigniter.com/user_guide/general/core_classes.html
| http://codeigniter.com/user_guide/general/creating_libraries.html
|
*/
$config['subclass_prefix'] = 'MY_';


/*
|--------------------------------------------------------------------------
| Allowed URL Characters
|--------------------------------------------------------------------------
|
| This lets you specify with a regular expression which characters are permitted
| within your URLs.  When someone tries to submit a URL with disallowed
| characters they will get a warning message.
|
| As a security measure you are STRONGLY encouraged to restrict URLs to
| as few characters as possible.  By default only these are allowed: a-z 0-9~%.:_-
|
| Leave blank to allow all characters -- but only if you are insane.
|
| DO NOT CHANGE THIS UNLESS YOU FULLY UNDERSTAND THE REPERCUSSIONS!!
|
*/
$config['permitted_uri_chars'] = 'a-zA-Z 0-9~%.:_,\-\(\)';


/*
|--------------------------------------------------------------------------
| Enable Query Strings
|--------------------------------------------------------------------------
|
| By default CodeIgniter uses search-engine friendly segment based URLs:
| example.com/who/what/where/
|
| You can optionally enable standard query string based URLs:
| example.com?who=me&what=something&where=here
|
| Options are: TRUE or FALSE (boolean)
|
| The other items let you set the query string "words" that will
| invoke your controllers and its functions:
| example.com/index.php?c=controller&m=function
|
| Please note that some of the helpers won't work as expected when
| this feature is enabled, since CodeIgniter is designed primarily to
| use segment based URLs.
|
*/
$config['enable_query_strings'] = FALSE;

/*
|--------------------------------------------------------------------------
| Error Logging Threshold
|--------------------------------------------------------------------------
|
| If you have enabled error logging, you can set an error threshold to 
| determine what gets logged. Threshold options are:
| You can enable error logging by setting a threshold over zero. The
| threshold determines what gets logged. Threshold options are:
|
|	0 = Disables logging, Error logging TURNED OFF
|	1 = Error Messages (including PHP errors)
|	2 = Debug Messages
|	3 = Informational Messages
|	4 = All Messages
|
| For a live site you'll usually only enable Errors (1) to be logged otherwise
| your log files will fill up very fast.
|
*/
$config['log_threshold'] = 0;

/*
|--------------------------------------------------------------------------
| Error Logging Directory Path
|--------------------------------------------------------------------------
|
| Leave this BLANK unless you would like to set something other than the default
| system/logs/ folder.  Use a full server path with trailing slash.
|
*/
$config['log_path'] = '';

/*
|--------------------------------------------------------------------------
| Date Format for Logs
|--------------------------------------------------------------------------
|
| Each item that is logged has an associated date. You can use PHP date
| codes to set your own date formatting
|
*/
$config['log_date_format'] = 'Y-m-d H:i:s';

/*
|--------------------------------------------------------------------------
| Default Date and Time formats of %D %T for all smarty templates
|--------------------------------------------------------------------------
|
| http://www.smarty.net/manual/en/language.modifier.date.format.php
|
*/
$config['date_format'] = '%m/%d/%y';
$config['time_format'] = '%H:%M:%S';
$config['decimals_separator'] = '.';
$config['thousands_separator'] = ' ';

/*
|--------------------------------------------------------------------------
| Encryption Key
|--------------------------------------------------------------------------
|
| If you use the Encryption class or the Sessions class with encryption
| enabled you MUST set an encryption key.  See the user guide for info.
|
*/
$config['encryption_key'] = "";

/*
|--------------------------------------------------------------------------
| Session Variables
|--------------------------------------------------------------------------
|
| 'session_cookie_name' = the name you want for the cookie
| 'encrypt_sess_cookie' = TRUE/FALSE (boolean).  Whether to encrypt the cookie
| 'session_expiration'  = the number of SECONDS you want the session to last.
|  by default sessions last 7200 seconds (two hours).  Set to zero for no expiration.
| 'time_to_update'		= how many seconds between CI refreshing Session Information
|
*/
$config['sess_cookie_name']		= 'w2d_session';
$config['sess_expiration']		= 7200;
$config['sess_encrypt_cookie']	= FALSE;
$config['sess_use_database']	= FALSE;
$config['sess_table_name']		= 'w2d_sessions';
$config['sess_match_ip']		= FALSE;
$config['sess_match_useragent']	= TRUE;
$config['sess_time_to_update'] 	= 300;

/*
|--------------------------------------------------------------------------
| 'Rememeber me' cookie will expire in this time (172800 = 2 days)
|--------------------------------------------------------------------------
|
*/
$config['remember_me_expiration'] 	= 172800;

/*
|--------------------------------------------------------------------------
| Cookie Related Variables
|--------------------------------------------------------------------------
|
| 'cookie_prefix' = Set a prefix if you need to avoid collisions
| 'cookie_domain' = Set to .your-domain.com for site-wide cookies
| 'cookie_path'   =  Typically will be a forward slash
|
*/
$config['cookie_prefix']	= "";
$config['cookie_domain']	= "";
$config['cookie_path']		= "/";

/*
|--------------------------------------------------------------------------
| Global XSS Filtering
|--------------------------------------------------------------------------
|
| Determines whether the XSS filter is always active when GET, POST or
| COOKIE data is encountered
|
*/
$config['global_xss_filtering'] = TRUE;

/*
|--------------------------------------------------------------------------
| Output Compression
|--------------------------------------------------------------------------
|
| Enables Gzip output compression for faster page loads.  When enabled,
| the output class will test whether your server supports Gzip.
| Even if it does, however, not all browsers support compression
| so enable only if you are reasonably sure your visitors can handle it.
|
| VERY IMPORTANT:  If you are getting a blank page when compression is enabled it
| means you are prematurely outputting something to your browser. It could
| even be a line of whitespace at the end of one of your scripts.  For
| compression to work, nothing can be sent before the output buffer is called
| by the output class.  Do not "echo" any values with compression enabled.
|
*/
$config['compress_output'] = FALSE;


/*
|--------------------------------------------------------------------------
| Reverse Proxy IPs
|--------------------------------------------------------------------------
|
| If your server is behind a reverse proxy, you must whitelist the proxy IP
| addresses from which CodeIgniter should trust the HTTP_X_FORWARDED_FOR
| header in order to properly identify the visitor's IP address.
| Comma-delimited, e.g. '10.0.1.200,10.0.1.201'
|
*/
$config['proxy_ips'] = '';

/*
|--------------------------------------------------------------------------
| Listings auto blocking time cycle
|--------------------------------------------------------------------------
|
*/
$config['auto_block_timer'] = 1*3600;


/*
|--------------------------------------------------------------------------
| Users content path for upload images, files
|--------------------------------------------------------------------------
|
|
*/
$config['users_content'] = array(
	'site_logo_file' => array(
		'upload_to' => 'users_images/site_logo/',
		'allowed_types' => 'jpg|gif|png',
	),
	'listing_logo_image' => array(
		'upload_to' => 'users_images/logos/',
		'allowed_types' => 'jpg|gif|png',
	),
	'listing_image' => array(
		'upload_to' => 'users_images/images/',
		'allowed_types' => 'jpg|gif|png',
		'thumbnails' => array(
			array(
				'upload_to' => 'users_images/thmbs/',
			),
			array(
				'upload_to' => 'users_images/thmbs_big/',
				'size' => '304*304',
			),
			array(
				'upload_to' => 'users_images/thmbs_small/',
				'size' => '100*120',
			),
			array(
				'upload_to' => 'users_images/thmbs_cropped/',
				'size' => '65*60',
				'crop' => true,
			),
		),
	),
	'user_logo_image' => array(
		'upload_to' => 'users_images/users_logos/',
		'allowed_types' => 'jpg|gif|png',
		'thumbnails' => array(
			array(
				'upload_to' => 'users_images/users_thmbs_logos/',
			),
		),
	),
	'listing_file' => array(
		'upload_to' => 'users_files/',
		'allowed_types' => 'doc|xls|pdf|zip|rar|txt|ppt|7zip',
	),
);

/*
|--------------------------------------------------------------------------
| Users content path from the root
|--------------------------------------------------------------------------
|
|--------------------------------------------------------------------------
| NOTE: in the case that you can't upload images in your admin panel 
| (like site logo or listings images), try to play with this variable:
|
| $config['users_content_server_path'] = $_SERVER['DOCUMENT_ROOT'] . '/' . $config['subdirectory'] . 'users_content/';
| or
| $config['users_content_server_path'] = '/' . $_SERVER['DOCUMENT_ROOT'] . '/' . $config['subdirectory'] . 'users_content/';
| or
| $config['users_content_server_path'] =  '/' . $config['subdirectory'] . '/users_content/';
| or
| $config['users_content_server_path'] = $config['subdirectory'] . 'users_content/';
|
|
*/
$config['users_content_server_path'] = $_SERVER['DOCUMENT_ROOT'] . '/' . $config['subdirectory'] . 'users_content/';


/*
|
|
*/
$config['users_content_http_path'] = $config['base_url'] . $config['subdirectory'] . 'users_content/';

/*
|--------------------------------------------------------------------------
| SMTP settings
|--------------------------------------------------------------------------
|
|
*/
$config['use_smtp_mail'] = false;
$config['smtp_port'] = 25;
$config['smtp_host'] = 'localhost';
$config['smtp_username'] = '';
$config['smtp_password'] = '';

/*
|--------------------------------------------------------------------------
| Max upload size of file
|--------------------------------------------------------------------------
|
|
*/
$config['max_upload_filesize'] = '2M';


/*
|--------------------------------------------------------------------------
| Url additional segments
|--------------------------------------------------------------------------
|
|
*/
$config['url_additional_segments'][] = 'lang';

/*
|--------------------------------------------------------------------------
| Currency codes
| these are common currencies, accurate currencies will be available
| for each payment gateway individualy
|--------------------------------------------------------------------------
|
|
*/
$config['currency_codes'][] = 'AUD';  // Australian Dollar 
$config['currency_codes'][] = 'CAD';  // Canadian Dollar 
$config['currency_codes'][] = 'EUR';  // Euro
$config['currency_codes'][] = 'GBP';  // British Pounds
$config['currency_codes'][] = 'JPY';  // Japanese Yen
$config['currency_codes'][] = 'USD';  // U.S. Dollars
$config['currency_codes'][] = 'NZD';  // New Zealand Dollar
$config['currency_codes'][] = 'CHF';  // Swiss Franc
$config['currency_codes'][] = 'HKD';  // Hong Kong Dollar 
$config['currency_codes'][] = 'SGD';  // Singapore Dollar
$config['currency_codes'][] = 'SEK';  // Swedish Krona
$config['currency_codes'][] = 'DKK';  // Danish Krone
$config['currency_codes'][] = 'PLN';  // Polish Zloty
$config['currency_codes'][] = 'NOK';  // Norwegian Krone
$config['currency_codes'][] = 'HUF';  // Hungarian Forint
$config['currency_codes'][] = 'CZK';  // Czech Koruna
$config['currency_codes'][] = 'ILS';  // Israeli New Sheqel
$config['currency_codes'][] = 'MXN';  // Mexican Peso
$config['currency_codes'][] = 'MYR';  // Malaysian Ringgit
$config['currency_codes'][] = 'BRL';  // Brazilian Real
$config['currency_codes'][] = 'PHP';  // Philippine Peso
$config['currency_codes'][] = 'TWD';  // Taiwan New Dollar
$config['currency_codes'][] = 'THB';  // Thai Baht
$config['currency_codes'][] = 'ARB';  // Argentine Peso
$config['currency_codes'][] = 'INR';  // Indian Rupee
$config['currency_codes'][] = 'ZAR';  // South African Rand
$config['currency_codes'][] = 'AED';  // South African Rand


/*
|--------------------------------------------------------------------------
| if true - categories list will be in alphobetical,
| false - you may set up your custom order
|--------------------------------------------------------------------------
|
|
*/
$config['categories_alphobetical_order'] = true;


/*
|--------------------------------------------------------------------------
| Google analytics listings pages path
| from root of the site, but without 'http://yoursite.com'
|--------------------------------------------------------------------------
|
|
*/
$config['ga_listings_path'] = '/' . $config['subdirectory'] . "listings/";

/*
|--------------------------------------------------------------------------
| Enable cache
|--------------------------------------------------------------------------
|
|
*/
$config['enable_cache'] = false;

/*
|--------------------------------------------------------------------------
| Smarty compile check
|--------------------------------------------------------------------------
|
| Smarty tests to see if the current template has 
| changed (different time stamp) since the last time it was compiled
|
*/
$config['smarty_compile_check'] = true;

/*
|--------------------------------------------------------------------------
| Translation mode
|--------------------------------------------------------------------------
|
| Helps to translate interface constants,
| If translation mode enabled - language vars will be reverced with its keys
|
*/
$config['translation_mode'] = false;

/*
|--------------------------------------------------------------------------
| Encode string into UTF8, need sometimes for ISO-8859-1 symbols
|--------------------------------------------------------------------------
|
|
*/
$config['utf8_encode'] = false;


/* End of file config.php */
/* Location: ./system/application/config/config.php */