	var map = null;
    var geocoder = null;
    var address = '';
    var scale = 
    {
    	min: 1, 
    	max: 20,
    	convertScale: function(value) {
    		return Math.round((value/((this.max-this.min)+1))*100);
    	},
    	backConvertScale: function(value) {
    		return Math.round((value*((this.max-this.min)+1))/100);
    	}
    };
    var glocation = (function(index, point, location, address_line_1, address_line_2, zip_or_postal_index, map_icon_file) {
    	this.index = index;
    	this.point = point;
    	this.location = location;
    	this.address_line_1 = address_line_1;
    	this.address_line_2 = address_line_2;
    	this.zip_or_postal_index = zip_or_postal_index;
    	this.map_icon_file = map_icon_file;
    	this.placeMarker = function() {
    		return placeMarker(this);
    	};
    	this.compileAddress = function() {
    		address = this.address_line_1;
    		if (this.address_line_2)
    			address += ", "+this.address_line_2;
    		if (this.location) {
    			if (this.address_line_1 || this.address_line_2)
    				address += " ";
    			address += this.location;
    		}
    		if (this.zip_or_postal_index)
    			address += " "+this.zip_or_postal_index;
    		return address;
    	};
    	this.compileHtmlAddress = function() {
    		address = this.address_line_1;
    		if (this.address_line_2)
    			address += ", "+this.address_line_2;
    		if (this.location) {
    			if (this.address_line_1 || this.address_line_2)
    				address += "<br />";
    			address += this.location;
    		}
    		if (this.zip_or_postal_index)
    			address += " "+this.zip_or_postal_index;
    		return address;
    	};
    	this.setPoint = function(point) {
    		this.point = point;
    	};
    });

    $(document).ready(function() 
	{
		// Do we connected to internet?
		if (window.GEvent !== undefined) {
			if (GBrowserIsCompatible() && document.getElementById("maps_canvas")) {
			    map = new GMap2(document.getElementById("maps_canvas"));
			    geocoder = new GClientGeocoder();
			    var coords_array_1 = new Array();
    			var coords_array_2 = new Array();

			    if ($(".map_coords_1[value!='']").length != 0 || $(".map_coords_2[value!='']").length != 0) {
			    	ajax_loader_show("Targeting...");
			    	$.each($(".location_block"), function(i, val) {
			    		if ($(".location_drop_boxes:eq("+i+")").length && (!$(".use_predefined_locations:eq("+i+")").length || $(".use_predefined_locations:eq("+i+")").is(":checked"))) {
							var locations_drop_boxes = [];
							$($(".location_drop_boxes:eq("+i+")").find(".location_dropdown_list").get().reverse()).each(function() {
								if ($(this).val())
									locations_drop_boxes.push($(this).children(":selected").text());
							});
							var location_string = locations_drop_boxes.join(', ');
						} else {
							var location_string = $(".location:eq("+i+")").val();
						}
			    		if ($(".map_coords_1:eq("+i+")").val()!='' && $(".map_coords_2:eq("+i+")").val()!='' &&
			    		($(".map_coords_1:eq("+i+")").val()!=0 || $(".map_coords_2:eq("+i+")").val()!=0)) {
				    		map_coords_1 = $(".map_coords_1:eq("+i+")").val();
				    		map_coords_2 = $(".map_coords_2:eq("+i+")").val();
				    		point = new GLatLng(map_coords_1, map_coords_2);
				    		coords_array_1.push(map_coords_1);
							coords_array_2.push(map_coords_2);
	
				    		var location_obj = new glocation(i, point, 
				    			location_string,
				    			$(".address_line_1:eq("+i+")").val(),
				    			$(".address_line_2:eq("+i+")").val(),
				    			$(".zip_or_postal_index:eq("+i+")").val(),
				    			$(".map_icon_file:eq("+i+")").val()
				    		);
				    		location_obj.placeMarker();
			    		}
			    	});
			    	
			    	setMapCenter(coords_array_1, coords_array_2);
			    } else {
			    	map.setCenter(new GLatLng(34, 0), 1);
			    }
			    map.addControl(new GSmallMapControl());
	    		map.addControl(new GMapTypeControl());
	    		
	    		// Check map zoom and save it into hidden field
	    		GEvent.addListener(map, 'zoomend', function() {
	                $(".map_zoom").val(scale.convertScale(map.getZoom()));
	                map_zoom = scale.convertScale(map.getZoom());
	        	});
	        	
	        	// Click on map event
				/*GEvent.addListener(map, 'click', function(overlay, point) {
					if (point !== undefined && window.coords_by_click !== undefined && window.coords_by_click) {
						if ($("#selected_location_num")) {
							var selected_location_num = $("#selected_location_num").val();
						}
						$(".manual_coords:eq("+selected_location_num+")").attr("checked", true);
						$(".manual_coords:eq("+selected_location_num+")").parent().parent().find(".manual_coords_block").show(200);
		
						$(".map_coords_1:eq("+selected_location_num+")").val(point.lat());
						$(".map_coords_2:eq("+selected_location_num+")").val(point.lng());
						generateMap();
					}
				});*/
			}
		}
	});
	
	function setMapCenter(coords_array_1, coords_array_2) {
		var count = 0;
		var bounds = new GLatLngBounds();
		for (count == 0; count<coords_array_1.length; count++)  {
			bounds.extend(new GLatLng(coords_array_1[count], coords_array_2[count]));
		}
		if (count == 1) {
			if ($(".map_zoom").val() == '')
				var zoom_level = 10;
			else
				var zoom_level = scale.backConvertScale(parseInt($(".map_zoom").val()));
		} else {
			// make bounds wider on 2%
			var zoom_level = scale.backConvertScale(scale.convertScale(map.getBoundsZoomLevel(bounds))-2);
		}
		map.setCenter(bounds.getCenter(), zoom_level);
		ajax_loader_hide();
	}

	function generateMap() {
		ajax_loader_show("Targeting...");
		var coords_array_1 = new Array();
    	var coords_array_2 = new Array();
		map.clearOverlays();
		$.each($(".location_block"), function(i, val) {
			if ($(".location_drop_boxes:eq("+i+")").length && (!$(".use_predefined_locations:eq("+i+")").length || $(".use_predefined_locations:eq("+i+")").is(":checked"))) {
				var locations_drop_boxes = [];
				$($(".location_drop_boxes:eq("+i+")").find(".location_dropdown_list").get().reverse()).each(function() {
					if ($(this).val())
						locations_drop_boxes.push($(this).children(":selected").text());
				});
				var location_string = locations_drop_boxes.join(', ');
			} else {
				var location_string = $(".location:eq("+i+")").val();
			}

			if ($(".manual_coords:eq("+i+")").is(":checked") && $(".map_coords_1:eq("+i+")").val()!='' && $(".map_coords_2:eq("+i+")").val()!='' && ($(".map_coords_1:eq("+i+")").val()!=0 || $(".map_coords_2:eq("+i+")").val()!=0)) {
				map_coords_1 = $(".map_coords_1:eq("+i+")").val();
				map_coords_2 = $(".map_coords_2:eq("+i+")").val();
				point = new GLatLng(map_coords_1, map_coords_2);
				coords_array_1.push(map_coords_1);
				coords_array_2.push(map_coords_2);

				var location_obj = new glocation(i, point, 
					location_string,
					$(".address_line_1:eq("+i+")").val(),
					$(".address_line_2:eq("+i+")").val(),
					$(".zip_or_postal_index:eq("+i+")").val(),
					$(".map_icon_file:eq("+i+")").val()
				);
				location_obj.placeMarker();
				//if (coords_array_1.length == $(".location_block").length) {
					setMapCenter(coords_array_1, coords_array_2);
				//}
			} else if(location_string) {
				var location_obj = new glocation(i, null, 
					location_string,
					$(".address_line_1:eq("+i+")").val(),
					$(".address_line_2:eq("+i+")").val(),
					$(".zip_or_postal_index:eq("+i+")").val(),
					$(".map_icon_file:eq("+i+")").val()
				);

				// Geocode by address
				geocoder.getLocations(location_obj.compileAddress(), function(response) {
					if (!response || response.Status.code != 200) {
						alert("Sorry, we were unable to geocode that address (address #"+(i+1)+")");
						ajax_loader_hide();
					} else {
						place = response.Placemark[0];
						point = new GLatLng(place.Point.coordinates[1], place.Point.coordinates[0]);
						$(".map_coords_1:eq("+i+")").val(place.Point.coordinates[1]);
						$(".map_coords_2:eq("+i+")").val(place.Point.coordinates[0]);
						map_coords_1 = place.Point.coordinates[1];
						map_coords_2 = place.Point.coordinates[0];
						coords_array_1.push(map_coords_1);
						coords_array_2.push(map_coords_2);
						location_obj.setPoint(point);
						location_obj.placeMarker();
						//if (coords_array_1.length == $(".location:text[value!='']").length) {
							setMapCenter(coords_array_1, coords_array_2);
						//}
					}
				});
			} else {
				ajax_loader_hide();
			}
		});
	}

	function placeMarker(glocation) {
		if (glocation.map_icon_file) {
			var customIcon = new GIcon(G_DEFAULT_ICON);
			customIcon.image = global_map_icons_path+'icons/'+glocation.map_icon_file;
			customIcon.iconSize = new GSize(32, 37);
			customIcon.iconAnchor = new GPoint(16,37);
			customIcon.shadow  = global_map_icons_path+'shadow-playground.png';
			customIcon.shadowSize = new GSize(51, 37);
			var marker = new GMarker(point, {icon:customIcon, draggable:true});
		} else {
			var customIcon = new GIcon(G_DEFAULT_ICON);
			customIcon.image = global_map_icons_path+'numeric/red'+(glocation.index+1)+".png";
			customIcon.iconSize = new GSize(27, 27);
			customIcon.iconAnchor = new GPoint(14,27);
			customIcon.shadow  = global_map_icons_path+'shadow-playground.png';
			customIcon.shadowSize = new GSize(41, 27);
			var marker = new GMarker(point, {icon:customIcon, draggable:true});
		}
		
		GEvent.addListener(marker, 'dragend', function(point) {
			if (point !== undefined) {
				var selected_location_num = glocation.index;
				$('#locations_accordion').accordion("activate", selected_location_num);
				$(".manual_coords:eq("+selected_location_num+")").attr("checked", true);
				$(".manual_coords:eq("+selected_location_num+")").parent().parent().find(".manual_coords_block").show(200);

				$(".map_coords_1:eq("+selected_location_num+")").val(point.lat());
				$(".map_coords_2:eq("+selected_location_num+")").val(point.lng());
				generateMap();
			}
		});

		GEvent.addListener(marker, 'click', function(point) {
			address = glocation.compileHtmlAddress();
			index = glocation.index;
			$('#locations_accordion').accordion("activate", index);
			var windowHtml = '';
			if (global_logo != '')
				windowHtml = '<img width="70px" align="left" style="float:left; padding-right:10px;" src="' + global_server_path + '/users_images/logos/' + global_logo + '">';
			windowHtml += '<b>' + global_title + '</b><br />' + address + '<div class="clear_float"></div>';
			marker.openInfoWindowHtml(windowHtml, {maxWidth:300});
		});

		map.addOverlay(marker);
	}