	var map = null;
	var baseIcon = null;
	var scale = 
    {
    	min: 1, 
    	max: 20,
    	convertScale: function(value) {
    		return Math.round((value/((this.max-this.min)+1))*100);
    	},
    	backConvertScale: function(value) {
    		return Math.round((value*((this.max-this.min)+1))/100);
    	}
    };

    $(document).ready(function() 
	{
		if (GBrowserIsCompatible() && document.getElementById("maps_canvas_summary")) {
		    map = new GMap2(document.getElementById("maps_canvas_summary"));
		    var bounds = new GLatLngBounds(new GLatLng(min_coord_1, min_coord_2), new GLatLng(max_coord_1, max_coord_2));

		    // make bounds wider on 2%
		    var zoom_level = scale.backConvertScale(scale.convertScale(map.getBoundsZoomLevel(bounds))-2);
			map.setCenter(bounds.getCenter(), zoom_level);

		    map.addControl(new GSmallMapControl());
    		map.addControl(new GMapTypeControl());

    		for (var i=0; i<listings_markers_options.length; i++) {
    			point = new GLatLng(listings_markers_options[i][0], listings_markers_options[i][1]);
    			placeMarkerSummary(
    				point, 
    				i, 
    				listings_markers_options[i][2], 
    				listings_markers_options[i][3], 
    				listings_markers_options[i][4], 
    				listings_markers_options[i][5], 
    				listings_markers_options[i][6], 
    				listings_markers_options[i][7], 
    				listings_markers_options[i][8], 
    				listings_markers_options[i][9]
    			);
    		}
		}
	});

	function placeMarkerSummary(point, index, global_map_icons_path, map_icon, map_icon_theme, address, listing_title, listing_logo, listing_url, listing_anchor)
	{
		if (map_icon && map_icon_theme) {
			var customIcon = new GIcon(G_DEFAULT_ICON);
			customIcon.image = global_map_icons_path+'icons/'+map_icon_theme+'/'+map_icon;
			customIcon.iconSize = new GSize(32, 37);
			customIcon.iconAnchor = new GPoint(16,37);
			customIcon.shadow  = global_map_icons_path+'shadow-playground.png';
			customIcon.shadowSize = new GSize(51, 37);
			var marker = new GMarker(point, {icon:customIcon});
		} else {
			var marker = new GMarker(point);
		}

		GEvent.addListener(marker, "click", function() {
			var windowHtml = '';
			if (listing_logo != '')
				windowHtml = '<img width="70px" align="left" style="float:left; padding-right:10px;" src="' + global_server_path + '/users_images/logos/' + listing_logo + '">';
			windowHtml += '<b>' + listing_title + '</b><br />' + address + '<div class="clear_float"></div>';
			windowHtml += '<br /><b><a href="#listing_id-' + listing_anchor + '">' + view_summary + '</a>&nbsp;&nbsp;&nbsp;<a href="' + listing_url + '">' + view_listing + '</a></b>';
			
			marker.openInfoWindowHtml(windowHtml, {maxWidth:300});
		});

		map.addOverlay(marker);
	}