	var map = null;
    var geocoder = null;
    var address = '';
    var scale = 
    {
    	min: 1, 
    	max: 20,
    	convertScale: function(value) {
    		return Math.round((value/((this.max-this.min)+1))*100);
    	},
    	backConvertScale: function(value) {
    		return Math.round((value*((this.max-this.min)+1))/100);
    	}
    };
    var glocation = (function(index, point, location, address_line_1, address_line_2, zip_or_postal_index, map_icon_file, listing_title, listing_logo, listing_url, listing_seo_title) {
    	this.index = index;
    	this.point = point;
    	this.location = location;
    	this.address_line_1 = address_line_1;
    	this.address_line_2 = address_line_2;
    	this.zip_or_postal_index = zip_or_postal_index;
    	this.map_icon_file = map_icon_file;
    	this.listing_title = listing_title;
    	this.listing_logo = listing_logo;
    	this.listing_url = listing_url;
    	this.listing_seo_title = listing_seo_title;
    	this.placeMarker = function() {
    		return placeMarker(this);
    	};
    	this.compileHtmlAddress = function() {
    		address = this.address_line_1;
    		if (this.address_line_2)
    			address += ", "+this.address_line_2;
    		if (this.location) {
    			if (this.address_line_1 || this.address_line_2)
    				address += "<br />";
    			address += this.location;
    		}
    		if (this.zip_or_postal_index)
    			address += " "+this.zip_or_postal_index;
    		return address;
    	};
    });

    $(document).ready(function() 
	{
		// Do we connected to internet?
		if (window.GEvent !== undefined && window.listings_markers_options !== undefined) {
			if (GBrowserIsCompatible() && document.getElementById("maps_canvas")) {
			    map = new GMap2(document.getElementById("maps_canvas"));
			    geocoder = new GClientGeocoder();

			    if (listings_markers_options.length) {
			    	var bounds = new GLatLngBounds();
			    	for (var i=0; i<listings_markers_options.length; i++) {
		    			map_coords_1 = listings_markers_options[i][0];
				    	map_coords_2 = listings_markers_options[i][1];
		    			point = new GLatLng(map_coords_1, map_coords_2);
		    			bounds.extend(point);

		    			var location_obj = new glocation(i, point, 
		    				listings_markers_options[i][2],
		    				listings_markers_options[i][3],
		    				listings_markers_options[i][4],
		    				listings_markers_options[i][5],
		    				listings_markers_options[i][6],
		    				listings_markers_options[i][8],
		    				listings_markers_options[i][9],
		    				listings_markers_options[i][10],
		    				listings_markers_options[i][11]
			    		);
			    		location_obj.placeMarker();
		    		}
					if (listings_markers_options.length == 1) {
						var zoom_level = scale.backConvertScale(listings_markers_options[0][7]);
					} else {
						// make bounds wider on 2%
						var zoom_level = scale.backConvertScale(scale.convertScale(map.getBoundsZoomLevel(bounds))-2);
					}
					map.setCenter(bounds.getCenter(), zoom_level);
			    } else {
			    	map.setCenter(new GLatLng(34, 0), 1);
			    }
			    map.addControl(new GSmallMapControl());
	    		map.addControl(new GMapTypeControl());
			}
		}
	});

	function placeMarker(glocation) {
		if (glocation.map_icon_file) {
			var customIcon = new GIcon(G_DEFAULT_ICON);
			customIcon.image = global_map_icons_path+'icons/'+glocation.map_icon_file;
			customIcon.iconSize = new GSize(32, 37);
			customIcon.iconAnchor = new GPoint(16,37);
			customIcon.shadow  = global_map_icons_path+'shadow-playground.png';
			customIcon.shadowSize = new GSize(51, 37);
			var marker = new GMarker(point, {icon:customIcon});
		} else {
			var customIcon = new GIcon(G_DEFAULT_ICON);
			customIcon.image = global_map_icons_path+"blank.png";
			customIcon.iconSize = new GSize(27, 27);
			customIcon.iconAnchor = new GPoint(14,27);
			customIcon.shadow  = global_map_icons_path+'shadow-playground.png';
			customIcon.shadowSize = new GSize(41, 27);
			var marker = new GMarker(point, {icon:customIcon});
		}

		GEvent.addListener(marker, 'click', function(point) {
			address = glocation.compileHtmlAddress();
			index = glocation.index;
			var windowHtml = '';
			if (glocation.listing_logo)
				windowHtml = '<img width="70px" align="left" style="float:left; padding-right:10px;" src="' + global_server_path + '/users_images/logos/' + glocation.listing_logo + '">';
			windowHtml += '<b>' + glocation.listing_title + '</b><br />' + address + '<div class="clear_float"></div>';
			if (glocation.listing_url)
				windowHtml += '<div class="5px"></div><b><a href="#listing_id-' + glocation.listing_seo_title + '">' + view_summary_label + '</a>&nbsp;&nbsp;&nbsp;<a href="' + glocation.listing_url + '">' + view_listing_label + '</a></b>';
			marker.openInfoWindowHtml(windowHtml, {maxWidth:300});
		});

		map.addOverlay(marker);
	}